Index: issm/trunk/externalpackages/export_fig/user_string.m
===================================================================
--- issm/trunk/externalpackages/export_fig/user_string.m	(revision 19105)
+++ issm/trunk/externalpackages/export_fig/user_string.m	(revision 21341)
@@ -1,23 +1,26 @@
+function string = user_string(string_name, string)
 %USER_STRING  Get/set a user specific string
 %
 % Examples:
-%   string = user_string(string_name)
-%   saved = user_string(string_name, new_string)
+%   string  = user_string(string_name)
+%   isSaved = user_string(string_name, new_string)
 %
 % Function to get and set a string in a system or user specific file. This
 % enables, for example, system specific paths to binaries to be saved.
 %
+% The specified string will be saved in a file named <string_name>.txt,
+% either in a subfolder named .ignore under this file's folder, or in the
+% user's prefdir folder (in case this file's folder is non-writable).
+%
 % IN:
-%   string_name - String containing the name of the string required. The
-%                 string is extracted from a file called (string_name).txt,
-%                 stored in the same directory as user_string.m.
-%   new_string - The new string to be saved under the name given by
-%                string_name.
+%   string_name - String containing the name of the string required, which
+%                 sets the filename storing the string: <string_name>.txt
+%   new_string  - The new string to be saved in the <string_name>.txt file
 %
 % OUT:
-%   string - The currently saved string. Default: ''.
-%   saved - Boolean indicating whether the save was succesful
+%   string  - The currently saved string. Default: ''
+%   isSaved - Boolean indicating whether the save was succesful
 
-% Copyright (C) Oliver Woodford 2011-2013
+% Copyright (C) Oliver Woodford 2011-2014, Yair Altman 2015-
 
 % This method of saving paths avoids changing .m files which might be in a
@@ -28,60 +31,75 @@
 
 % 10/01/2013 - Access files in text, not binary mode, as latter can cause
-% errors. Thanks to Christian for pointing this out.
+%              errors. Thanks to Christian for pointing this out.
+% 29/05/2015 - Save file in prefdir if current folder is non-writable (issue #74)
 
-function string = user_string(string_name, string)
-if ~ischar(string_name)
-    error('string_name must be a string.');
-end
-% Create the full filename
-string_name = fullfile(fileparts(mfilename('fullpath')), '.ignore', [string_name '.txt']);
-if nargin > 1
-    % Set string
-    if ~ischar(string)
-        error('new_string must be a string.');
+    if ~ischar(string_name)
+        error('string_name must be a string.');
     end
-    % Make sure the save directory exists
-    dname = fileparts(string_name);
-    if ~exist(dname, 'dir')
-        % Create the directory
-        try
-            if ~mkdir(dname)                
+    % Create the full filename
+    fname = [string_name '.txt'];
+    dname = fullfile(fileparts(mfilename('fullpath')), '.ignore');
+    file_name = fullfile(dname, fname);
+    if nargin > 1
+        % Set string
+        if ~ischar(string)
+            error('new_string must be a string.');
+        end
+        % Make sure the save directory exists
+        %dname = fileparts(file_name);
+        if ~exist(dname, 'dir')
+            % Create the directory
+            try
+                if ~mkdir(dname)
+                    string = false;
+                    return
+                end
+            catch
                 string = false;
                 return
             end
+            % Make it hidden
+            try
+                fileattrib(dname, '+h');
+            catch
+            end
+        end
+        % Write the file
+        fid = fopen(file_name, 'wt');
+        if fid == -1
+            % file cannot be created/updated - use prefdir if file does not already exist
+            % (if file exists but is simply not writable, don't create a duplicate in prefdir)
+            if ~exist(file_name,'file')
+                file_name = fullfile(prefdir, fname);
+                fid = fopen(file_name, 'wt');
+            end
+            if fid == -1
+                string = false;
+                return;
+            end
+        end
+        try
+            fprintf(fid, '%s', string);
         catch
+            fclose(fid);
             string = false;
             return
         end
-        % Make it hidden
-        try
-            fileattrib(dname, '+h');
-        catch
+        fclose(fid);
+        string = true;
+    else
+        % Get string
+        fid = fopen(file_name, 'rt');
+        if fid == -1
+            % file cannot be read, try to read the file in prefdir
+            file_name = fullfile(prefdir, fname);
+            fid = fopen(file_name, 'rt');
+            if fid == -1
+                string = '';
+                return
+            end
         end
+        string = fgetl(fid);
+        fclose(fid);
     end
-    % Write the file
-    fid = fopen(string_name, 'wt');
-    if fid == -1
-        string = false;
-        return
-    end
-    try
-        fprintf(fid, '%s', string);
-    catch
-        fclose(fid);
-        string = false;
-        return
-    end
-    fclose(fid);
-    string = true;
-else
-    % Get string
-    fid = fopen(string_name, 'rt');
-    if fid == -1
-        string = '';
-        return
-    end
-    string = fgetl(fid);
-    fclose(fid);
 end
-end
Index: issm/trunk/externalpackages/export_fig/using_hg2.m
===================================================================
--- issm/trunk/externalpackages/export_fig/using_hg2.m	(revision 19105)
+++ issm/trunk/externalpackages/export_fig/using_hg2.m	(revision 21341)
@@ -1,3 +1,3 @@
-%USING_HG2 Determine if the HG2 graphics pipeline is used
+%USING_HG2 Determine if the HG2 graphics engine is used
 %
 %   tf = using_hg2(fig)
@@ -7,12 +7,30 @@
 %
 %OUT:
-%   tf - boolean indicating whether the HG2 graphics pipeline is being used
+%   tf - boolean indicating whether the HG2 graphics engine is being used
 %        (true) or not (false).
 
+% 19/06/2015 - Suppress warning in R2015b; cache result for improved performance
+% 06/06/2016 - Fixed issue #156 (bad return value in R2016b)
+
 function tf = using_hg2(fig)
-try
-    tf = ~graphicsversion(fig, 'handlegraphics');
-catch
-    tf = false;
+    persistent tf_cached
+    if isempty(tf_cached)
+        try
+            if nargin < 1,  fig = figure('visible','off');  end
+            oldWarn = warning('off','MATLAB:graphicsversion:GraphicsVersionRemoval');
+            try
+                % This generates a [supressed] warning in R2015b:
+                tf = ~graphicsversion(fig, 'handlegraphics');
+            catch
+                tf = ~verLessThan('matlab','8.4');  % =R2014b
+            end
+            warning(oldWarn);
+        catch
+            tf = false;
+        end
+        if nargin < 1,  delete(fig);  end
+        tf_cached = tf;
+    else
+        tf = tf_cached;
+    end
 end
-end
